﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.Runtime.InteropServices;

//#include "..\\USB_PAT_Tower_DLL\\USB_PAT_Tower_DLL.h"
//#include "..\\USB_PAT_Tower_DLL\\USB_PAT_Definition.h"

//#pragma comment(lib, "..\\USB_PAT_Tower_DLL\\Release\\USB_PAT_Tower.lib")

namespace UPT_DLL_TEST_CS
{
    public partial class Form1 : Form
    {
        const int OFF_STATIC = 0;
        const int ON_STATIC = 1;
        const int PATT_MOVE1 = 2;
        const int PATT_MOVE2 = 3;
        const int PATT_MOVE3 = 4;
        const int PATT_MOVE4 = 5;
        const int PATT_KEEP = 9;

        /* Color of LED Unit */
        const int UPT_RED = 10;
        const int UPT_YEL = 11;
        const int UPT_GRN = 12;
        const int UPT_BLU = 13;
        const int UPT_CLR = 14;

        /* Pitch of Buzzer */
        const int BUZ_PITCH_OFF = 20;
        const int BUZ_PITCH1 = 21;
        const int BUZ_PITCH2 = 22;
        const int BUZ_PITCH3 = 23;
        const int BUZ_PITCH4 = 24;
        const int BUZ_PITCH5 = 25;
        const int BUZ_PITCH6 = 26;
        const int BUZ_PITCH7 = 27;
        const int BUZ_PITCH8 = 28;
        const int BUZ_PITCH9 = 29;
        const int BUZ_PITCH10 = 30;
        const int BUZ_PITCH11 = 31;
        const int BUZ_PITCH12 = 32;
        const int BUZ_PITCH13 = 33;
        const int BUZ_PITCH_DFLT = 59;

        /* ERROR Value */
        const int ERR_NOEXIST = -1;
        const int ERR_LOCKED = -2;
        const int ERR_CONNECTION = -3;
        const int ERR_PARAM = -4;
        const int ERR_TRANSFAIL_EVNT = -5;
        const int ERR_TRANSFAIL_TMOUT = -6;
        const int ERR_TRANSFAIL_SEND = -7;
        const int ERR_DLL_LINK = -8;

        /* Connection */
        [DllImport("USB_PAT_Tower.dll", CallingConvention = CallingConvention.Cdecl)]
        static extern int UPT_Open();

        [DllImport("USB_PAT_Tower.dll", CallingConvention = CallingConvention.Cdecl)]
        static extern void UPT_Close();

        /* LED Conrtol */
        [DllImport("USB_PAT_Tower.dll", CallingConvention = CallingConvention.Cdecl)]
        static extern int UPT_SetLight(byte color, byte led_state);
        [DllImport("USB_PAT_Tower.dll", CallingConvention = CallingConvention.Cdecl)]
        static extern int UPT_SetTower(byte red, byte yel, byte grn, byte blu, byte clr);

        /* Buzzer Control */
        [DllImport("USB_PAT_Tower.dll", CallingConvention = CallingConvention.Cdecl)]
        static extern int UPT_SetBuz(byte buz_state, byte limit);
        [DllImport("USB_PAT_Tower.dll", CallingConvention = CallingConvention.Cdecl)]
        static extern int UPT_SetBuzEx(byte buz_state, byte limit, byte pitch1, byte pitch2);

        [DllImport("USB_PAT_Tower.dll", CallingConvention = CallingConvention.Cdecl)]
        static extern int UPT_Reset();

        [DllImport("USB_PAT_Tower.dll", CallingConvention = CallingConvention.Cdecl)]
        static extern ushort UPT_GetFirmVer();
        [DllImport("USB_PAT_Tower.dll", CallingConvention = CallingConvention.Cdecl)]
        static extern ushort UPT_GetDllVer();

        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            int open_stat = 0;

            ushort dll_ver = 0;
            ushort firm_ver = 0;
            String dll_str, firm_str;

            /* DLL version acquisition */
            dll_ver = UPT_GetDllVer();
            dll_str = "DLL ver : " + Convert.ToString(get_ver_maj(dll_ver)) + "." + Convert.ToString(get_ver_min(dll_ver)) + "." + Convert.ToString(get_ver_rev(dll_ver)) + "\r\n";

            /* Connection */
            open_stat = UPT_Open();
            if (open_stat == 0)
            {
                UPT_Reset();

                /* Firmware version acquisition */
                firm_ver = UPT_GetFirmVer();
                firm_str = "Firm ver : " + Convert.ToString(get_ver_maj(firm_ver)) + "." + Convert.ToString(get_ver_min(firm_ver)) + "." + Convert.ToString(get_ver_rev(firm_ver)) + "\r\n";

                /* Firmware version display  */
                textBox1.Text = dll_str + firm_str;

                /* RED・White ON＋Buzzer */
                UPT_SetTower(ON_STATIC, OFF_STATIC, OFF_STATIC, OFF_STATIC, ON_STATIC);
                UPT_SetBuzEx(ON_STATIC, 0, BUZ_PITCH1, BUZ_PITCH_DFLT);
                System.Threading.Thread.Sleep(700);
                UPT_Reset();
                System.Threading.Thread.Sleep(300);

                /* Yellow・Blue　ON＋Buzzer */
                UPT_SetTower(OFF_STATIC, ON_STATIC, OFF_STATIC, ON_STATIC, OFF_STATIC);
                UPT_SetBuzEx(ON_STATIC, 0, BUZ_PITCH1, BUZ_PITCH_DFLT);
                System.Threading.Thread.Sleep(700);
                UPT_Reset();
                System.Threading.Thread.Sleep(300);

                /* Green ON＋Buzzer */
                UPT_SetTower(OFF_STATIC, OFF_STATIC, ON_STATIC, OFF_STATIC, OFF_STATIC);
                UPT_SetBuzEx(ON_STATIC, 1, BUZ_PITCH13, BUZ_PITCH_DFLT);

                UPT_Close();	/* Connection finished */
            }
            else
            {
                firm_str = "Failure to UPT_Open\n";

                /*  Firmware version display */
                textBox1.Text = dll_str + firm_str;
            }
        }

        byte get_ver_maj(ushort ver)
        {
	        return (byte)((ver >> 8) & 0xFF);
        }

        byte get_ver_min(ushort ver)
        {
            return (byte)((ver >> 4) & 0x0F);
        }

        byte get_ver_rev(ushort ver)
        {
            return (byte)(ver & 0x0F);
        }
    }
}
